/**
	$Id: PingRequestHandler.java 4478 2008-09-05 15:15:54Z jari $

	Copyright (C) 2006 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
*/
package net.sf.basedb.clients.jobagent.handlers;

import java.net.Socket;

import net.sf.basedb.clients.jobagent.Agent;
import net.sf.basedb.util.jobagent.RequestHandler;

/**
	This is a request handler for the <code>ping</code> command. It simply returns
	OK if the command is <code>ping</code>. Otherwise it returns 
	<code>FAILED Unhandled command: &lt;cmd&gt;</code>.

	@author nicklas
	@version 2.0
	@base.modified $Date: 2008-09-05 17:15:54 +0200 (Fri, 05 Sep 2008) $
*/
public class PingRequestHandler
	implements RequestHandler
{

	/**
		Create a new handler for the ping command.
		@param agent The agent 
	*/
	public PingRequestHandler(Agent agent)
	{}
	
	/*
		From the RequestHandler interface
		-------------------------------------------
	*/
	/**
		@return OK if <code>cmd=ping</code>
	*/
	public String handleCmd(Socket incoming, String cmd)
	{
		return "ping".equals(cmd) ? "OK" : "FAILED Unhandled command: " + cmd;
	}
	// -------------------------------------------

}
