/*
	$Id: AlreadyLoggedInException.java 4479 2008-09-05 15:16:27Z jari $

	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Hakkinen

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
*/
package net.sf.basedb.core;

/**
	This exception is thrown if you try to log in
	but are already logged in.

	@author Nicklas
	@version 2.0
*/
public class AlreadyLoggedInException
	extends PermissionDeniedException
{

	/**
		
	*/
	private static final long serialVersionUID = 3492139536509366378L;

	/**
		Creates a new <code>AlreadyLoggedInException</code>.
	  	@param login Login name of the already logged in account. 
	*/
	public AlreadyLoggedInException(String login)
	{
		super("Another user is already logged in: "+login);
	}

}


