/*
	$Id: InvalidPasswordException.java 4479 2008-09-05 15:16:27Z jari $

	Copyright (C) 2005 Jari Hakkinen, Nicklas Nordborg
	Copyright (C) 2006 Jari Hakkinen

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
*/
package net.sf.basedb.core;

/**
	Exceptions of this type are thrown when user tries to log in, but
	the password is incorrect.

	@author Nicklas
	@version 2.0
	@since 2.0
*/
public class InvalidPasswordException
	extends BaseException
{

	/**
		
	*/
	private static final long serialVersionUID = -7696617448870042174L;

	/**
		Create a new <code>InvalidPasswordException</code> object with 
		the specified <code>message</code>

		@param message The message to throw with the exception
	*/
	public InvalidPasswordException(String message)
	{
		super("Invalid password. "+message);
	}

}


