/*
	$Id: GroupGroups.java 4479 2008-09-05 15:16:27Z jari $

	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Hakkinen

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
*/
package net.sf.basedb.core.data.keyring;
import java.io.Serializable;

/**
	Class for mapping the <code>GroupGroups</code> table.
	@author Nicklas
	@version 2.0
	@base.modified $Date: 2008-09-05 17:16:27 +0200 (Fri, 05 Sep 2008) $
*/
public final class GroupGroups
	implements Serializable
{

	/**
		
	*/
	private static final long serialVersionUID = 3058557529392800869L;
	private int parentId;
	private int childId;
	
	/**
		Create a new <code>GroupGroups</code> object.
	*/
	public GroupGroups()
	{}

	/**
		Get the id of the parent group.
	*/
	public int getParentId()
	{
		return parentId;
	}
	/**
		Set the id of the parent group.
	*/
	public void setParentId(int parentId)
	{
		this.parentId = parentId;
	}

	/**
		Get the id of the child group.
	*/
	public int getChildId()
	{
		return childId;
	}
	/**
		Set the id of the child group.
	*/
	public void setChildId(int childId)
	{
		this.childId = childId;
	}

	/**
		Check if this object is equal to another <code>GroupGroups</code>
		object. They are considered to be the same if the parent and 
		child id are the same.
	*/
	public boolean equals(Object o)
	{
		if ((o == null) || (getClass() != o.getClass())) return false;
		GroupGroups gg = (GroupGroups)o;
		return (gg.parentId == this.parentId) && (gg.childId == this.childId);
	}
	
	/**
		Calculate the hash code for the object.
	*/
	public int hashCode()
	{
		return (int)(31*parentId + 17*childId);
	}
}
