/**
	$Id: AllEventsFilter.java 4479 2008-09-05 15:16:27Z jari $

	Copyright (C) 2008 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
*/
package net.sf.basedb.util.extensions.events;

import net.sf.basedb.util.extensions.Extension;
import net.sf.basedb.util.extensions.ExtensionPoint;

/**
	Event filter that passes all events.

	@author nicklas
	@version 2.8
	@base.modified $Date: 2008-09-05 17:16:27 +0200 (Fri, 05 Sep 2008) $
 */
public class AllEventsFilter
	implements EventFilter
{

	/**
		Create a event type filter that passes all events.
	*/
	public AllEventsFilter()
	{}
	
	/**
		@return Always TRUE
	*/
	@Override
	public boolean shouldSend(EventType event, ExtensionPoint<?> extensionPoint,
			Extension<?> extension)
	{
		return true;
	}

}
