/**
	$Id: NameableInfo.java 4480 2008-09-05 15:16:58Z jari $

	Copyright (C) 2007 Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
*/
package net.sf.basedb.info;

/**
  	@author Martin
  	@version 2.5
 	
 */
public interface NameableInfo
{
	/**
	 	Get the name of the info object
	  	@return name A String
	 */
	public String getName();
	
	/**
	 	Set the info object's name
	  	@param name The name to set.
	 */
	public void setName(String name);
	
	/**
	 	Gets the description of the info object
	  	@return description A String.
	 */
	public String getDescription();
	
	/**
	 	Sets the description of an info object.
	 	@param description The description to set.
	 */
	public void setDescription(String description);
}
