/*
	$Id: TestPresets.java 4480 2008-09-05 15:16:58Z jari $

	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
*/
import net.sf.basedb.core.Presets;
import net.sf.basedb.core.Presets.Preset;

public class TestPresets
{

	static boolean ok = true;
	public static void main(String[] args)
	{
		TestUtil.checkArgs(args);
		TestUtil.begin();
		ok = test_all();
		TestUtil.stop();
	}

	static boolean test_all()
	{
		write("++Testing XML presets");

		Presets presets = new Presets();
		test_create(presets, "one", "first");
		test_create(presets, "two", "second");
		test_to_xml(presets);
		write("++Testing XML presets "+(ok ? "OK" : "Failed")+"\n");
		return ok;
	}

	static Preset test_create(Presets presets, String name, String value)
	{
		if (presets == null) return null;
		Preset p = null;
		try
		{
			p = presets.getPreset(name);
			p.setSetting("testing", value);
			write("--Create preset: "+name+" OK");
		}
		catch (Throwable ex)
		{
			write("--Create preset: "+name+" FAILED");
			ex.printStackTrace();
			ok = false;
		}
		return p;
	}
	
	static void test_to_xml(Presets presets)
	{
		if (presets == null) return;
		try
		{
			String xml = presets.asXml();
			if (!TestUtil.getSilent())
			{
				write(xml);
			}
			write("--Create XML from preset: OK");
		}
		catch (Throwable ex)
		{
			write("--Create XML from preset: FAILED");
			ex.printStackTrace();
			ok = false;
		}
	}
	
	static void write(String message)
	{
		System.out.println(message);
	}

}

