<%-- $Id: view_user.jsp 4476 2008-09-05 15:14:42Z jari $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.Quota"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.Role"
	import="net.sf.basedb.core.Directory"
	import="net.sf.basedb.core.ExtendedProperties"
	import="net.sf.basedb.core.ExtendedProperty"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="java.util.Map"
	import="java.util.Date"
	import="java.util.List"	
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%!
	private static final Item itemType = Item.USER;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.ITEM);
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);

	String title = null;
	User user = User.getById(dc, itemId);

	final boolean writePermission = user.hasPermission(Permission.WRITE);
	final boolean deletePermission = user.hasPermission(Permission.DELETE);
	final boolean isRemoved = user.isRemoved();
	final boolean isUsed = isRemoved && user.isUsed();
	final boolean deletePermanentlyPermission = deletePermission && !isUsed;
	%>

	<base:page title="<%=title%>">
	<base:head scripts="table.js,tabcontrol.js" styles="toolbar.css,table.css,headertabcontrol.css,path.css">
		<script language="JavaScript">
		function editItem()
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>, true);
		}
		function deleteItem()
		{
			location.replace('index.jsp?ID=<%=ID%>&cmd=DeleteItem&item_id=<%=itemId%>');
		}
		function restoreItem()
		{
			location.replace('index.jsp?ID=<%=ID%>&cmd=RestoreItem&item_id=<%=itemId%>');
		}
		function deleteItemPermanently()
		{
			Main.deleteItemPermanently('<%=ID%>', true, '<%=itemType.name()%>', <%=itemId%>, '&callback=itemDeleted');
		}
		function itemDeleted()
		{
			Main.listItems('<%=ID%>', '<%=itemType.name()%>');
		}
		function showUsingItems()
		{
			Main.showUsingItems('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>);
		}
		function runPlugin(cmd)
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd='+cmd+'&item_id=<%=itemId%>', 'RunPlugin'+cmd, 740, 540);
		}
		</script>
	</base:head>
	<base:body>
		<p>
		<p:path>
			<p:pathelement title="Users" href="<%="index.jsp?ID="+ID%>" />
			<p:pathelement title="<%=HTML.encodeTags(user.getName())%>" />
		</p:path>
		
		<t:tabcontrol id="main" active="properties">
		<t:tab id="properties" title="Properties">
		
		<tbl:toolbar
			>
			<tbl:button 
				disabled="<%=writePermission ? false : true%>" 
				image="<%=writePermission ? "edit.gif" : "edit_disabled.gif"%>" 
				onclick="editItem()" 
				title="Edit&hellip;" 
				tooltip="<%=writePermission ? "Edit this user" : "You do not have permission to edit this user"%>" 
			/>
			<tbl:button 
				disabled="<%=deletePermission ? false : true%>" 
				image="<%=deletePermission ? "delete.gif" : "delete_disabled.gif"%>" 
				onclick="deleteItem()" 
				title="Delete"
				visible="<%=!user.isRemoved()%>"
				tooltip="<%=deletePermission ? "Delete this user" : "You do not have permission to delete this user"%>" 
			/>
			<tbl:button 
				disabled="<%=writePermission ? false : true%>" 
				image="<%=writePermission ? "restore.gif" : "restore_disabled.gif"%>" 
				onclick="restoreItem()" 
				title="Restore"
				visible="<%=user.isRemoved()%>"
				tooltip="<%=writePermission ? "Restore this user" : "You do not have permission to restore this user"%>" 
			/>
			<tbl:button 
				image="import.gif" 
				onclick="runPlugin('ImportItem')" 
				title="Import&hellip;" 
				tooltip="Import data" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
			/>
			<tbl:button 
				image="export.gif" 
				onclick="runPlugin('ExportItem')" 
				title="Export&hellip;" 
				tooltip="Export data" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
			/>
			<tbl:button 
				image="runplugin.gif" 
				onclick="runPlugin('RunPlugin')" 
				title="Run plugin&hellip;" 
				tooltip="Run a plugin" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
			/>
			<tbl:button
				image="help.gif"
				onclick="<%="Main.openHelp('" + ID +"', 'user.view.properties')"%>"
				title="Help&hellip;"
				tooltip="Get help about this page"
			/>
			</tbl:toolbar>
		<div class="boxedbottom">
			<div class="itemstatus">Permissions on this item: <i><%=PermissionUtil.getFullPermissionNames(user)%></i></div>
			<%
			if (user.isRemoved())
			{
				%>
				<div class="itemstatus">
					<base:icon 
						image="<%=deletePermanentlyPermission ? "deleted.gif" : "deleted_disabled.gif"%>"
						onclick="<%=deletePermanentlyPermission ? "deleteItemPermanently()" : null%>"
						tooltip="<%=deletePermanentlyPermission ? "Permanently delete this item" : null%>"
						visible="<%=isRemoved%>"> This item has been flagged for deletion<br></base:icon>
					<base:icon image="used.gif" 
						onclick="showUsingItems()"
						tooltip="Show the items that are using this one"
						visible="<%=isUsed%>"> This item is used by other items and can't be permanently deleted<br></base:icon>
				</div>
				<%
			}
			%>
				<table class="form" cellspacing=0>
				<tr valign="baseline">
					<td class="prompt" width="10%">Name</td>
					<td width="40%"><%=HTML.encodeTags(user.getName())%></td>
					<td>&nbsp;</td>
					<td class="prompt" width="10%">Email</td>
					<td width="40%"><%=HTML.niceFormat(user.getEmail())%></td>
				</tr>
				<tr valign="baseline">
					<td class="prompt">System ID</td>
					<td><%=HTML.encodeTags(user.getSystemId())%></td>
					<td>&nbsp;</td>
					<td class="prompt">Organisation</td>
					<td><%=HTML.encodeTags(user.getOrganisation())%></td>
				</tr>
				<tr valign="baseline">
					<td class="prompt">Login</td>
					<td><%=HTML.encodeTags(user.getLogin())%></td>
					<td>&nbsp;</td>
					<td class="prompt">Address</td>
					<td><%=HTML.niceFormat(user.getAddress())%></td>
				</tr>
				<tr valign="baseline">
					<td class="prompt">External ID</td>
					<td><%=HTML.encodeTags(user.getExternalId())%></td>
					<td>&nbsp;</td>
					<td class="prompt">Phone</td>
					<td><%=HTML.encodeTags(user.getPhone())%></td>
				</tr>
				<tr valign="baseline">
					<td class="prompt">Home directory</td>
					<td><base:propertyvalue item="<%=user%>" property="homeDirectory" /></td>
					<td>&nbsp;</td>
					<td class="prompt">Fax</td>
					<td><%=HTML.encodeTags(user.getFax())%></td>
				</tr>
				<tr valign="baseline">
					<td class="prompt">Quota</td>
					<td><base:propertyvalue item="<%=user%>" property="quota" /></td>
					<td>&nbsp;</td>
					<td class="prompt">Url</td>
					<td><%=HTML.niceFormat(user.getUrl())%></td>
				</tr>
				<tr valign="baseline">
					<td class="prompt">Quota group</td>
					<td><base:propertyvalue item="<%=user%>" property="quotaGroup" /></td>
				</tr>
				<tr valign="baseline">
					<td class="prompt">Expiration date</td>
					<td><%=user.getExpirationDate() == null ? "<i>- never -</i>" : 
						dateFormatter.format(user.getExpirationDate())%></td>
				</tr>
				<tr valign="baseline">
					<td class="prompt">Multi-user account</td>
					<td><%=user.isMultiuserAccount() ? "yes" : "no"%></td>
				</tr>
				<tr valign="baseline">
					<td class="prompt">Disabled</td>
					<td><%=user.isDisabled() ? "yes" : "no"%></td>
				</tr>
				<tr valign="baseline">
					<td class="prompt">Description</td>
					<td colspan="3"><%=HTML.niceFormat(user.getDescription())%></td>
				</tr>
				</table>
				
				<%
				List<ExtendedProperty> extendedProperties = ExtendedProperties.getProperties("UserData");
				if (extendedProperties != null)
				{
					%>
					<h4>Additional information</h4>
					<table class="form" cellspacing="0">	
						<%
						boolean needsTr = true;
						for (ExtendedProperty ep : extendedProperties)
						{
							String name = ep.getName();
							Formatter f = FormatterFactory.getExtendedPropertyFormatter(sc, ep);
							String value = f.format(user.getExtended(name));
							%>
								<%=needsTr ? "<tr valign=\"top\">" : "" %>
								<td class="prompt" width="10%"><%=HTML.encodeTags(ep.getTitle())%></td>
								<td width="40%"><%=value%></td>
								<td>&nbsp;</td>
								<%=needsTr ? "" : "</tr>"%>
							<%
							needsTr = !needsTr;
						}
						%>
						<%=needsTr ? "" : "</tr>"%>
					</table>
					<%
				}
				else
				{
					%>
					<h4>Additional information</h4>
					There are no additional information
					<%
				}

			ItemQuery<Group> groupQuery = user.getGroups();
			groupQuery.include(Include.ALL);
			groupQuery.order(Orders.asc(Hql.property("name")));
			ItemResultList<Group> groups = groupQuery.list(dc);
			
			ItemQuery<Role> roleQuery = user.getRoles();
			roleQuery.include(Include.ALL);
			roleQuery.order(Orders.asc(Hql.property("name")));
			ItemResultList<Role> roles = roleQuery.list(dc);
			
			if (groups.size() == 0 && roles.size() == 0)
			{
				%>
				<h4>Membership</h4>
				This user isn't member of any group or role (or, you don't have permission to view them).
				<%
			}
			else
			{
				%>
				<h4 class="docked">Membership</h4>
				<tbl:table
					id="membership"
					clazz="itemlist"
					columns="all"
					>
				<tbl:columndef 
					id="name"
					title="Name"
				/>
				<tbl:columndef 
					id="type"
					title="Type"
				/>
				<tbl:columndef 
					id="description"
					title="Description"
				/>
				<tbl:data>
					<tbl:columns>
					</tbl:columns>
					<tbl:rows>
					<%
					for (Group group : groups)
					{
						%>
						<tbl:row>
							<tbl:cell column="name"><base:icon 
									image="deleted.gif" 
									tooltip="This item has been scheduled for deletion" 
									visible="<%=group.isRemoved()%>"
								/><%=Base.getLinkedName(ID, group, false, true)%></tbl:cell>
							<tbl:cell column="type">Group</tbl:cell>
							<tbl:cell column="description"><%=HTML.encodeTags(group.getDescription())%></tbl:cell>
						</tbl:row>
						<%
					}
					for (Role role : roles)
					{
						%>
						<tbl:row>
							<tbl:cell column="name"><base:icon 
									image="deleted.gif" 
									tooltip="This item has been scheduled for deletion" 
									visible="<%=role.isRemoved()%>"
								/><%=Base.getLinkedName(ID, role, false, true)%></tbl:cell>
							<tbl:cell column="type">Role</tbl:cell>
							<tbl:cell column="description"><%=HTML.encodeTags(role.getDescription())%></tbl:cell>
						</tbl:row>
						<%
					}
					%>
					</tbl:rows>
				</tbl:data>
				</tbl:table>
				<%
			}
			%>
		</div>
			</t:tab>
			</t:tabcontrol>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}

%>
