<%-- $Id: not_logged_in.jsp 4476 2008-09-05 15:14:42Z jari $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
	------------------------------------------------------------------

	This page is used to catch NotLoggedInExceptions which are
	directed here via the exception.jsp page. NotLoggedInExceptions
	happen when a user tries to access a protected page without beeing
	logged in. Typically the exception is thrown from the method that
	retrieves the BaseControl object:

	BASE.getExistingBaseControl(pageContext);

	This page will display a new login form allowing the user
	to login again and continue with what he/she was doing.

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.util.Values"
	isErrorPage="true"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld"
%>
<%
final SessionControl sc = Base.getSessionControl(pageContext, true);
final String ID = sc.getId();
final String root = request.getContextPath()+"/";
final String redirect = Values.getString((String)request.getAttribute("redirect"));

%>
<base:page type="default" menu="exception" title="Not logged in">
<base:head scripts="md5.js" styles="login.css">
	<script language="JavaScript">
	// hide menubar and resize if it is a popup window
	function fixWindow()
	{
		if (window.opener != null)
		{
			// popup window
			Main.hide('menubar');
			var width = Main.getWindowWidth();
			var height = Main.getWindowHeight();
			if (height < 400) height = 400;
			if (width < 600) width = 600; // >
			window.resizeTo(width, height);
		}
		setFocus();
	}
	// Set the focus on either the login or password field.
	function setFocus()
	{
		var frm = document.forms['login'];
		var topWindow = getTopWindow(false);
		if (topWindow.lastLogin) 
		{
			frm.login.value = topWindow.lastLogin;
			Main.show('timeout');
		}
		if (frm.encrypt && topWindow.encrypt != undefined)
		{
			frm.encrypt.checked = topWindow.encrypt;
		}
		if (frm.login.value == '')
		{
			frm.login.focus();
		}
		else
		{
			frm.password.focus();
			frm.password.select();
		}
	}
	
	function mainPage()
	{
		var topWindow = getTopWindow(true);
		topWindow.main.document.location = '<%=root%>main.jsp';
	}
	function getTopWindow(closePopups)
	{
		var topWindow = window.top;
		if (topWindow.opener != null)
		{
			var i = 1;
			while ((topWindow.opener != null) && (i <10))  // >
			{
				i = i+1
				var popupWindow = topWindow;
				topWindow = topWindow.opener.top;
			}
			if (closePopups) popupWindow.close();
		}
		return topWindow;
	}
	function doLogin()
	{
		var frm = document.forms['login'];
		if (frm.encrypt && frm.encrypt.checked)
		{
			var password = frm.password.value;
			var md5password = hex_md5(password);
			md5password = hex_md5(md5password + ':<%=sc.getChallenge()%>');
			frm.encrypted_password.value = md5password;
			frm.password.value = '';
		}
		Main.openPopup('', 'Login', 300, 200);
		frm.submit();
	}
	</script>
</base:head>
<base:body onload="fixWindow()">
	<div align="center">
		<form action="<%=root%>login.jsp?again=1" method="post" name="login" target="Login" onsubmit="return false;">
			<input type="hidden" name="ID" value="<%=ID%>">
			<input type="hidden" name="redirect" value="<%=redirect%>">
			<input type="hidden" name="encrypted_password" value="">
			
			<table class="loginform" width="100%" border="0" align="center">
			<tr><td colspan="2" align="center">
				<div class="error" id="timeout" style="display: none;">
					You have been automatically logged out due to inactivity or because the 
					server has been restarted.<br>
					You may log in again and continue your work but unsaved changes 
					may have been lost.
				</div>
			</td></tr>
			<tr>
				<td>
					<div align="center">
						<img src="<%=root%>images/baselogo.png" alt="BASE logo" width=122 height=58>
					</div>
				</td>
				<td>
					<table>
					<tr>
						<td class="prompt">Login</td>
						<td><input class="text" type="text" name="login" value="" size=15 maxlength=100></td>
					</tr>
					<tr>
						<td class="prompt">Password</td>
						<td>
							<input class="text" type="password" name="password" size=15 maxlength=80 
								onkeypress="return Forms.submitOnEnter(event, doLogin)">
						</td>
						<td><base:button image="login.png" onclick="doLogin();" title="Login" /></td>
						<td><base:button onclick="mainPage();" title="Cancel" /></td>
					</tr>
					<%
					if (Application.isUsingInternalAuthentication())
					{
						%>
						<tr>
							<td class="prompt">Encrypt password</td>
							<td>
								<input type="checkbox" name="encrypt" checked value="1"><br>
							</td>
						</tr>
						<%
					}
					%>
					<tr>
						<td colspan="4">
						<%
						String forgotPassword = sc.getClientDefaultSetting("server.forgotten.password");
						if (forgotPassword != null)
						{
							%>
							<base:icon image="bullet.gif" />
							<a href="javascript:Main.openPopup('<%=root%>info/forgot_password.jsp?ID=<%=ID%>', 'ForgotPassword', 500, 300)" title="Click here if you have forgotten your password">Forgot your password?</a>
							<%
						}
						%>
						</td>
					</tr>
					</table>
				</td>
			</tr>
			</table>
		</form>
	</div>
</base:body>
</base:page>
