<%-- $Id: edit_eventtype.jsp 4476 2008-09-05 15:14:42Z jari $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.PlateType"
	import="net.sf.basedb.core.PlateEventType"
	import="net.sf.basedb.core.ProtocolType"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.PLATEEVENTTYPE;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final int plateTypeId = Values.getInt(request.getParameter("platetype_id"));
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	PlateEventType eventType = null;
	PlateType plateType = null;
	
	ProtocolType currentProtocolType = null;
	boolean readCurrentProtocolType = true;
	int maxOrdinal = 0;
	
	// Load recently used items
	List<ProtocolType> recentProtocolTypes = (List<ProtocolType>)cc.getRecent(dc, Item.PROTOCOLTYPE);

	if (itemId == 0)
	{
		title = "Create event type";
		cc.removeObject("item");
		plateType = PlateType.getById(dc, plateTypeId);
		if (cc.getPropertyFilter("protocolType.name") != null)
		{
			currentProtocolType = Base.getFirstMatching(dc, ProtocolType.getQuery(), "name", cc.getPropertyFilter("protocolType.name"));
		}
		maxOrdinal = (int)plateType.getEventTypes().count(dc);
	}
	else
	{
		eventType = PlateEventType.getById(dc, itemId);
		plateType = eventType.getPlateType();
		cc.setObject("item", eventType);
		title = "Edit event type -- " + HTML.encodeTags(plateType.getName());
		try
		{
			currentProtocolType = eventType.getProtocolType();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentProtocolType = false;
		}
	}
	if (eventType != null && !eventType.hasPermission(Permission.WRITE))
	{
		throw new PermissionDeniedException(Permission.WRITE, itemType.toString());
	}
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	%>

	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js" styles="tabcontrol.css">
		<script language="JavaScript">
		// Validate the "EventType" tab
		function validateEventType()
		{
			var frm = document.forms['eventtype'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			else if (Main.trimString(frm.ordinal.value) == '')
			{
				alert("You must enter an ordinal");
				frm.ordinal.focus();
				return false;
			}
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['eventtype'];
			if (TabControl.validateActiveTab('settings'))
			{
				frm.submit();
			}
		}
		
		function selectProtocolTypeOnClick()
		{
			var frm = document.forms['eventtype'];
			var url = '../../../admin/protocoltypes/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setProtocolTypeCallback';
			if (frm.protocoltype_id.length > 1) 
			{
				var id = Math.abs(parseInt(frm.protocoltype_id[1].value));				
				url += '&item_id='+id;
			}
			Main.openPopup(url, 'SelectProtocolType', 1000, 700);
		}
		function setProtocolTypeCallback(id, name)
		{
			var frm = document.forms['eventtype'];
			var list = frm.protocoltype_id;
			if (list.length < 2 || list[1].value == '0') // >
			{
				Forms.addListOption(list, 1, new Option());
			}
			list[1].value = id;
			list[1].text = name;
			list.selectedIndex = 1;
		}
		
		function init()
		{
			var frm = document.forms['eventtype'];
			<%
			if (eventType == null)
			{
				%>
				frm.name.focus();
				frm.name.select();
				<%
			}
			%>
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="eventtype" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">
		<input type="hidden" name="platetype_id" value="<%=plateTypeId%>">

		<h3 class="docked"><%=title%> <base:help tabcontrol="settings" /></h3>
		<t:tabcontrol id="settings" contentstyle="<%="height: "+(int)(scale*160)+"px;"%>" 
			position="bottom" remember="<%=eventType != null%>">
		<t:tab id="info" title="Event type" validate="validateEventType()" helpid="plateeventtype.edit">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Name</td>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(eventType == null ? Values.getString(cc.getPropertyValue("name"), "New event type") : eventType.getName())%>" 
					size="40" maxlength="<%=PlateEventType.MAX_NAME_LENGTH%>"></td>
			</tr>
			<tr>
				<td class="prompt">Ordinal</td>
				<td><input <%=requiredClazz%> type="text" name="ordinal" 
					value="<%=eventType == null ? Values.getInt(cc.getPropertyValue("ordinal"), maxOrdinal+1) : eventType.getOrdinal()%>" 
					size="12" maxlength="10" onkeypress="return Numbers.integerOnly(event)"></td>
			</tr>
			<tr>
				<td class="prompt">Protocol type</td>
				<td>
					<base:select 
						id="protocoltype_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentProtocolType%>"
						denied="<%=!readCurrentProtocolType%>"
						recent="<%=recentProtocolTypes%>"
						newitem="<%=eventType == null%>"
						onselect="selectProtocolTypeOnClick()"
					/>
				</td>
			</tr>

			<tr valign=top>
				<td class="prompt">Description</td>
				<td nowrap>
					<textarea <%=clazz%> rows="4" cols="40" name="description" wrap="virtual"
						><%=HTML.encodeTags(eventType == null ? cc.getPropertyValue("description") : eventType.getDescription())%></textarea>
					<a href="javascript:Main.zoom('Description', 'eventtype', 'description')"
						title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			</table>
			<div align=right>&nbsp;<i><base:icon image="required.gif" /> = required information</i></div>
		</t:tab>
		</t:tabcontrol>

		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Save" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
