<%-- $Id: submit_user.jsp 4476 2008-09-05 15:14:42Z jari $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg
	Copyright (C) 2007 Johan Enell, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
	------------------------------------------------------------------

	This page will save user information and preferences.

	@param cmd The command to execute
		- SaveSettings: Save the settings from the settings.jsp page.
		- SavePreferences: Save preferences from the preferences.jsp page.

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.formatter.FormatterSettings"
	import="net.sf.basedb.util.Values"
	import="java.util.Arrays"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
SessionControl sc = Base.getExistingSessionControl(pageContext, true);
String ID = sc.getId();
String cmd = request.getParameter("cmd");
String message = "";
String root = request.getContextPath()+"/";

DbControl dc = sc.newDbControl();
try
{
	if ("SaveSettings".equals(cmd))
	{
		String email = Values.getStringOrNull(request.getParameter("email"));
		if (email != null && !HTML.isValidEmail(email))
		{
			throw new WebException("popup", "Invalid email address",
				"The email address {1} is not a valid email address.",
				HTML.encodeTags(email)
			);
		}
		User user = (User)sc.getSessionSetting("user");
		dc.reattachItem(user);

		// Contact information tab
		user.setEmail(email);
		user.setOrganisation(Values.getStringOrNull(request.getParameter("organisation")));
		user.setAddress(Values.getStringOrNull(request.getParameter("address")));
		user.setPhone(Values.getStringOrNull(request.getParameter("phone")));
		user.setFax(Values.getStringOrNull(request.getParameter("fax")));
		user.setUrl(Values.getStringOrNull(request.getParameter("url")));

		// Password tab
		String password = Values.getStringOrNull(request.getParameter("password"));
		if (password != null) user.setPassword(password);

		// Other settings tab
		user.setDescription(Values.getStringOrNull(request.getParameter("description")));

		dc.commit();
		sc.setSessionSetting("user", null);
		message = "Information saved";
	}
	else if ("SavePreferences".equals(cmd))
	{
		int newScale = Values.getInt(request.getParameter("scale"), 100);
		sc.setUserClientSetting("appearance.scale", Integer.toString(newScale));
		sc.setUserClientSetting("appearance.fontsize", Values.getString(request.getParameter("fontsize"), "size_m.css"));
		sc.setSessionSetting("appearance.scale", new Float(newScale / 100.0));
		ItemContext cc = sc.getCurrentContext(Item.USERCLIENTSETTING);
		int maxRecent = Base.getMaxRecent(sc);
	
		String toolbar = request.getParameter("toolbar");
		boolean hasImages = true;
		boolean hasText = true;
		if ("text".equals(toolbar))
		{
			hasImages = false;
		}
		else if ("images".equals(toolbar))
		{
			hasText = false;
		}
		sc.setUserClientSetting("toolbar.images", hasImages ? "1" : "0");
		sc.setUserClientSetting("toolbar.text", hasText ? "1" : "0");
		String minColor = Values.getString(request.getParameter("mincolor"), "0000FF");
		String midColor = Values.getString(request.getParameter("midcolor"), "FFFFFF");
		String maxColor = Values.getString(request.getParameter("maxcolor"), "FFFF00");
		sc.setUserClientSetting("ratiocolor.min", minColor);
		sc.setUserClientSetting("ratiocolor.mid", midColor);
		sc.setUserClientSetting("ratiocolor.max", maxColor);
		cc.setRecent("colors", minColor + "," + midColor + "," + maxColor, maxRecent);
		
		String dateFormat = request.getParameter("date_format");
		String dateTimeFormat = request.getParameter("datetime_format");
		FormatterSettings.setDateFormat(sc, dateFormat);
		FormatterSettings.setDateTimeFormat(sc, dateTimeFormat);
		cc.setRecent("dateFormats", dateFormat, maxRecent);
		cc.setRecent("dateTimeFormats", dateTimeFormat, maxRecent);

		int numDecimals = Values.getInt(request.getParameter("decimals"), 2);
		FormatterSettings.setNumDecimals(sc, numDecimals);
		
		// Plugins tab
		sc.setUserClientSetting("plugins.sendmessage", Values.getString(request.getParameter("sendmessage"), "0"));
		sc.setUserClientSetting("plugins.removejob", Values.getString(request.getParameter("removejob"), "0"));
		sc.setUserClientSetting("plugins.showWarnings", Values.getString(request.getParameter("show_warnings"), "0"));
		
		// Recent items tab
		int newMaxUsed = Values.getInt(request.getParameter("maxUsed"), 4);
		sc.setUserClientSetting("appearance.recent", Integer.toString(newMaxUsed));
		sc.setSessionSetting("appearance.recent", newMaxUsed);
		int newMaxViewed = Values.getInt(request.getParameter("maxViewed"), 6);
		sc.setUserClientSetting("menu.mostRecent.maxViewed", Integer.toString(newMaxViewed));
		sc.setUserClientSetting("menu.mostRecent.loadNames", Values.getString(request.getParameter("loadNames"), "0"));

		String[] stickyItems = request.getParameterValues("sticky_items");
		sc.setUserClientSetting("menu.mostRecent", 
			stickyItems == null ? "" : Values.getString(Arrays.asList(stickyItems), ":", true));
		
		message = "Preferences saved";
	}
	else if ("ReloadPermissions".equals(cmd))
	{
		sc.reloadPermissions();
		sc.reloadSettings(true, false);
		sc.setSessionSetting("menu.standard.html", null);
		message = "Permissions reloaded";
	}
	else if ("ResetFilters".equals(cmd))
	{
		boolean inDatabase = Values.getBoolean(request.getParameter("database"));
		int numDeleted = sc.deleteCurrentContexts(null, true, inDatabase);
		message = numDeleted + " list settings deleted";
	}
	else
	{
		throw new WebException("popup", "Invalid command", "The command {1} is not recognised as a valid command.", cmd);
	}
}
finally
{
	if (dc != null) dc.close();
}
response.sendRedirect(root + "common/close_popup.jsp?ID="+ID+"&refresh_opener=1&&message="+HTML.urlEncode(message));
%>

